src/Entity/PrestashopOrder.php
<?php

namespace App\Entity;

use App\Repository\PrestashopOrderRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=PrestashopOrderRepository::class)
 */
class PrestashopOrder
{
    const STATUS_IN_PROGRESS = 0;
    const STATUS_ORDERED = 1;
    const STATUS_VALIDATED = 2;

    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="date")
     */
    private $date;

    /**
     * @ORM\Column(type="decimal", precision=26, scale=6)
     */
    private $price;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $reference;

    /**
     * @ORM\OneToMany(targetEntity=PrestashopOrderDetail::class, mappedBy="prestashopOrder", orphanRemoval=true)
     */
    private $prestashopOrderDetails;

    /**
     * @ORM\ManyToOne(targetEntity=Supplier::class, inversedBy="prestashopOrders")
     * @ORM\JoinColumn(nullable=false)
     */
    private $supplier;

    /**
     * @ORM\Column(type="integer")
     */
    private $status = 0;

    /**
     * @ORM\ManyToOne(targetEntity=CompanyAddress::class, inversedBy="prestashop_orders")
     */
    private $companyAddress;

    /**
     * @ORM\ManyToOne(targetEntity=CompanyAddress::class, inversedBy="invoice_prestashop_orders")
     */
    private $invoice_address;


    public function __construct()
    {
        $this->prestashopOrderDetails = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getDate(): ?\DateTimeInterface
    {
        return $this->date;
    }

    public function setDate(\DateTimeInterface $date): self
    {
        $this->date = $date;

        return $this;
    }

    public function getPrice(): ?string
    {
        $this->price = 0;
        $this->getPrestashopOrderDetails()->map(function (PrestashopOrderDetail $detail) {
            $this->price += $detail->getPrice();
        });
        return $this->price;
    }

    public function setPrice(string $price): self
    {
        $this->price = $price;

        return $this;
    }


    public function getReference(): ?string
    {
        return $this->reference;
    }

    public function setReference(string $reference): self
    {
        $this->reference = $reference;

        return $this;
    }

    /**
     * @return Collection|PrestashopOrderDetail[]
     */
    public function getPrestashopOrderDetails(): Collection
    {
        return $this->prestashopOrderDetails;
    }

    public function addPrestashopOrderDetail(PrestashopOrderDetail $prestashopOrderDetail): self
    {
        if (!$this->prestashopOrderDetails->contains($prestashopOrderDetail)) {
            $this->prestashopOrderDetails[] = $prestashopOrderDetail;
            $prestashopOrderDetail->setPrestashopOrder($this);
        }

        return $this;
    }

    public function removePrestashopOrderDetail(PrestashopOrderDetail $prestashopOrderDetail): self
    {
        if ($this->prestashopOrderDetails->contains($prestashopOrderDetail)) {
            $this->prestashopOrderDetails->removeElement($prestashopOrderDetail);
            // set the owning side to null (unless already changed)
            if ($prestashopOrderDetail->getPrestashopOrder() === $this) {
                $prestashopOrderDetail->setPrestashopOrder(null);
            }
        }

        return $this;
    }

    public function getSupplier(): ?Supplier
    {
        return $this->supplier;
    }

    public function setSupplier(?Supplier $supplier): self
    {
        $this->supplier = $supplier;

        return $this;
    }

    public function __toString()
    {
        return (string)$this->reference;
    }

    public function getStatus(): ?int
    {
        return $this->status;
    }

    public function getStatusName()
    {
        switch ($this->status) {
            case self::STATUS_IN_PROGRESS:
                return "in progress";
            case self::STATUS_ORDERED:
                return "ordered";
            case self::STATUS_VALIDATED:
                return "validated";
        }
    }

    public function setStatus(int $status): self
    {
        $this->status = $status;

        return $this;
    }

    public function getProductCount()
    {
        $count = 0;
        foreach ($this->getPrestashopOrderDetails() as $detail)
            $count += $detail->getQuantity();
        return $count;
    }

    public function getCompanyAddress(): ?CompanyAddress
    {
        return $this->companyAddress;
    }

    public function setCompanyAddress(?CompanyAddress $companyAddress): self
    {
        $this->companyAddress = $companyAddress;

        return $this;
    }

    public function getInvoiceAddress(): ?CompanyAddress
    {
        return $this->invoice_address;
    }

    public function setInvoiceAddress(?CompanyAddress $invoice_address): self
    {
        $this->invoice_address = $invoice_address;

        return $this;
    }
}

src/Entity/Product.php
<?php

namespace App\Entity;

use App\Repository\ProductRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=ProductRepository::class)
 */
class Product
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="integer", unique=true)
     */
    private $id_product;

    /**
     * @ORM\Column(type="integer")
     */
    private $id_supplier;

    /**
     * @ORM\Column(type="integer")
     */
    private $id_category_default;

    /**
     * @ORM\Column(type="integer")
     */
    private $id_tax_rules_group;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $ean13;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $isbn;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $upc;

    /**
     * @ORM\Column(type="decimal", precision=23, scale=6, nullable=true)
     */
    private $ecotax;

    /**
     * @ORM\Column(type="integer")
     */
    private $quantity;

    /**
     * @ORM\Column(type="integer")
     */
    private $minimal_quantity;

    /**
     * @ORM\Column(type="decimal", precision=26, scale=6)
     */
    private $price;

    /**
     * @ORM\Column(type="decimal", precision=26, scale=6)
     */
    private $wholesale_price;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $reference;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $supplier_reference;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $location;

    /**
     * @ORM\Column(type="decimal", precision=26, scale=6)
     */
    private $width;

    /**
     * @ORM\Column(type="decimal", precision=26, scale=6)
     */
    private $height;

    /**
     * @ORM\Column(type="decimal", precision=26, scale=6)
     */
    private $depth;

    /**
     * @ORM\Column(type="decimal", precision=26, scale=6)
     */
    private $weight;

    /**
     * @ORM\Column(type="integer")
     */
    private $out_of_stock;

    /**
     * @ORM\ManyToMany(targetEntity=Category::class, mappedBy="products")
     */
    private $categories;

    /**
     * @ORM\OneToMany(targetEntity=CartProduct::class, mappedBy="product")
     */
    private $cartProducts;

    /**
     * @ORM\OneToMany(targetEntity=ProductAttribute::class, mappedBy="product")
     */
    private $productAttributes;

    /**
     * @ORM\OneToMany(targetEntity=OrderProduct::class, mappedBy="product")
     */
    private $orderProducts;

    /**
     * @ORM\OneToMany(targetEntity=OrderDetails::class, mappedBy="connected_product")
     */
    private $orderDetails;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $image;


    /**
     * @ORM\OneToMany(targetEntity=Stock::class, mappedBy="product")
     */
    private $stocks;

    /**
     * @ORM\ManyToOne(targetEntity=Supplier::class, inversedBy="products")
     */
    private $supplier;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $name;

    /**
     * @ORM\OneToMany(targetEntity=SupplierOrderDetails::class, mappedBy="product")
     */
    private $supplierOrderDetails;

    /**
     * @ORM\OneToMany(targetEntity=PrestashopOrderDetail::class, mappedBy="product")
     */
    private $prestashopOrderDetails;

    /**
     * @ORM\ManyToOne(targetEntity=Brand::class, inversedBy="products")
     */
    private $manufacturer;

    public function __construct()
    {
        $this->categories = new ArrayCollection();
        $this->cartProducts = new ArrayCollection();
        $this->productAttributes = new ArrayCollection();
        $this->orderProducts = new ArrayCollection();
        $this->orderDetails = new ArrayCollection();
        $this->stocks = new ArrayCollection();
        $this->supplierOrderDetails = new ArrayCollection();
        $this->prestashopOrderDetails = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getIdProduct(): ?int
    {
        return $this->id_product;
    }

    public function setIdProduct(int $id_product): self
    {
        $this->id_product = $id_product;

        return $this;
    }

    public function getIdSupplier(): ?int
    {
        return $this->id_supplier;
    }

    public function setIdSupplier(int $id_supplier): self
    {
        $this->id_supplier = $id_supplier;

        return $this;
    }

    public function getIdCategoryDefault(): ?int
    {
        return $this->id_category_default;
    }

    public function setIdCategoryDefault(int $id_category_default): self
    {
        $this->id_category_default = $id_category_default;

        return $this;
    }

    public function getIdTaxRulesGroup(): ?int
    {
        return $this->id_tax_rules_group;
    }

    public function setIdTaxRulesGroup(int $id_tax_rules_group): self
    {
        $this->id_tax_rules_group = $id_tax_rules_group;

        return $this;
    }

    public function getEan13(): ?string
    {
        return $this->ean13;
    }

    public function setEan13(string $ean13): self
    {
        $this->ean13 = $ean13;

        return $this;
    }

    public function getIsbn(): ?string
    {
        return $this->isbn;
    }

    public function setIsbn(string $isbn): self
    {
        $this->isbn = $isbn;

        return $this;
    }

    public function getUpc(): ?string
    {
        return $this->upc;
    }

    public function setUpc(string $upc): self
    {
        $this->upc = $upc;

        return $this;
    }

    public function getEcotax(): ?string
    {
        return $this->ecotax;
    }

    public function setEcotax(?string $ecotax): self
    {
        $this->ecotax = $ecotax;

        return $this;
    }

    public function getQuantity(): ?int
    {
        return $this->quantity;
    }

    public function setQuantity(int $quantity): self
    {
        $this->quantity = $quantity;

        return $this;
    }

    public function getMinimalQuantity(): ?int
    {
        return $this->minimal_quantity;
    }

    public function setMinimalQuantity(int $minimal_quantity): self
    {
        $this->minimal_quantity = $minimal_quantity;

        return $this;
    }

    public function getPrice(): ?string
    {
        return $this->price;
    }

    public function setPrice(string $price): self
    {
        $this->price = $price;

        return $this;
    }

    public function getWholesalePrice(): ?string
    {
        return $this->wholesale_price;
    }

    public function setWholesalePrice(string $wholesale_price): self
    {
        $this->wholesale_price = $wholesale_price;

        return $this;
    }

    public function getReference(): ?string
    {
        return $this->reference;
    }

    public function setReference(string $reference): self
    {
        $this->reference = $reference;

        return $this;
    }

    public function getSupplierReference(): ?string
    {
        return $this->supplier_reference;
    }

    public function setSupplierReference(string $supplier_reference): self
    {
        $this->supplier_reference = $supplier_reference;

        return $this;
    }

    public function getLocation(): ?string
    {
        return $this->location;
    }

    public function setLocation(string $location): self
    {
        $this->location = $location;

        return $this;
    }

    public function getWidth(): ?string
    {
        return $this->width;
    }

    public function setWidth(string $width): self
    {
        $this->width = $width;

        return $this;
    }

    public function getHeight(): ?string
    {
        return $this->height;
    }

    public function setHeight(string $height): self
    {
        $this->height = $height;

        return $this;
    }

    public function getDepth(): ?string
    {
        return $this->depth;
    }

    public function setDepth(string $depth): self
    {
        $this->depth = $depth;

        return $this;
    }

    public function getWeight(): ?string
    {
        return $this->weight;
    }

    public function setWeight(string $weight): self
    {
        $this->weight = $weight;

        return $this;
    }

    public function getOutOfStock(): ?int
    {
        return $this->out_of_stock;
    }

    public function setOutOfStock(int $out_of_stock): self
    {
        $this->out_of_stock = $out_of_stock;

        return $this;
    }


    /**
     * @return Collection|Category[]
     */
    public function getCategories(): Collection
    {
        return $this->categories;
    }

    public function addCategory(Category $category): self
    {
        if (!$this->categories->contains($category)) {
            $this->categories[] = $category;
            $category->addProduct($this);
        }

        return $this;
    }

    public function removeCategory(Category $category): self
    {
        if ($this->categories->contains($category)) {
            $this->categories->removeElement($category);
            $category->removeProduct($this);
        }

        return $this;
    }

    /**
     * @return Collection|CartProduct[]
     */
    public function getCartProducts(): Collection
    {
        return $this->cartProducts;
    }

    public function addCartProduct(CartProduct $cartProduct): self
    {
        if (!$this->cartProducts->contains($cartProduct)) {
            $this->cartProducts[] = $cartProduct;
            $cartProduct->setProduct($this);
        }

        return $this;
    }

    public function removeCartProduct(CartProduct $cartProduct): self
    {
        if ($this->cartProducts->contains($cartProduct)) {
            $this->cartProducts->removeElement($cartProduct);
            // set the owning side to null (unless already changed)

templates/pdf/productEticket.html.twig
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>COMMANDE({{ order.reference }})</title>
</head>
<body>

<style>
    .border-bottom td {
        border-bottom: 1px solid black;
    }

    table {
        width: 100%
    }

    .m-t-b-100 {
        margin: 100px 0;
    }

    .grey {
        background-color: lightgrey;
    }

    .total {
        float: right;
        width: 50%;
        margin-top: 100px;
    }

    .b-grey {
        border: 2px solid darkgrey;
    }

    .align-left {
        text-align: left;
    }

    .title-container {
        width: 100%;
        height: 150px;
        position: relative
    }

    .title-container div {
        position: absolute;
        width: 50%
    }
</style>
<div class="title-container">
    <div style="left:0">
        <img width="100px" src="{{ image }}" alt="">
    </div>
    <div style="right:0">
        <h3 style="text-align: center">COMMANDE({{ order.reference }})</h3>
    </div>
</div>
<table class="address-table m-t-b-100">
    <thead>
    <tr style="color:darkgrey">
        <th class="align-left" scope="col">Adresse de facturation</th>
        <th class="align-left" scope="col">Adresse de livraison</th>
        <th class="align-left" scope="col">A l'attention de :</th>
    </tr>
    </thead>
    <tbody>
    <tr>
        <td>
            {% if order.companyAddress %}
                {{ order.companyAddress.firstname }}
                {{ order.companyAddress.lastname }}
            {% endif %}
        </td>
        <td>
            {% if order.invoiceAddress %}
                {{ order.invoiceAddress.firstname }}
                {{ order.invoiceAddress.lastname }}
            {% endif %}
        </td>
        <td>
            {{ order.supplier.name }}
        </td>
    </tr>
    <tr>
        <td>
            {% if order.companyAddress %}
                {{ order.companyAddress.alias }}
            {% endif %}
        </td>
        <td>
            {% if order.invoiceAddress %}
                {{ order.invoiceAddress.alias }}
            {% endif %}
        </td>
        <td>
            {{ order.supplier.description }}
        </td>
    </tr>
    <tr>
        <td>
            {% if order.companyAddress %}
                {{ order.companyAddress.address1 }}
            {% endif %}
        </td>
        <td>
            {% if order.invoiceAddress %}
                {{ order.invoiceAddress.address1 }}
            {% endif %}
        </td>
        <td>
            {# {{ order.supplier.address1 }} #}
        </td>
    </tr>

    <tr>
        <td>
            {% if order.companyAddress %}
                {{ order.companyAddress.address2 }}
            {% endif %}

        </td>
        <td>
            {% if order.invoiceAddress %}
                {{ order.invoiceAddress.address2 }}
            {% endif %}
        </td>
        <td>
            {# {{ order.supplier.address2 }} #}
        </td>
    </tr>
    <tr>
        <td>
            {% if order.companyAddress %}
                {{ order.companyAddress.postcode }}
                {{ order.companyAddress.city }}
            {% endif %}

        </td>
        <td>
            {% if order.invoiceAddress %}
                {{ order.invoiceAddress.postcode }}
                {{ order.invoiceAddress.city }}
            {% endif %}

        </td>
        {# <th> #}
        {# {{ order.supplier.postcode }} #}
        {# {{ order.supplier.city }} #}
        {# </th> #}
    </tr>
    <tr>
        <td>
            {% if order.companyAddress %}
                {{ order.companyAddress.phone }}
            {% endif %}

        </td>
        <td>
            {% if order.invoiceAddress %}
                {{ order.invoiceAddress.phone }}
            {% endif %}
        </td>
        <td>
            {# {{ order.supplier.phone }} #}
        </td>
    </tr>
    <tr>
        <td>
            {# {{ order.companyAddress.email }} #}
        </td>
        <td>
            {# {{ order.invoiceAddress.email }} #}
        </td>
        <td>
            {{ order.supplier.email }}
        </td>
    </tr>

    </tbody>
</table>

<table>
    <thead>
    <tr>
        <th class="grey" scope="col">Numéro de commande</th>
        <th class="grey" scope="col">Date de commande</th>
    </tr>
    </thead>
    <tbody>
    <tr>
        <td>
            {{ order.reference }}
        </td>
        <td>
            {{ order.date|date("m/d/Y") }}
        </td>
    </tr>
    </tbody>
</table>
<table class="m-t-b-100">
    <thead>
    <tr>
        <th class="grey" scope="col">Référence</th>
        <th class="grey" scope="col">Description</th>
        <th class="grey" scope="col">Prix HT</th>
        <th class="grey" scope="col">Qté</th>
        <th class="grey" scope="col">Total</th>
    </tr>
    </thead>
    <tbody>
    {% for orderProduct in order.prestashopOrderDetails %}
        {% set product = orderProduct.product?orderProduct.product:orderProduct.offlineProduct %}
        <tr class="border-bottom">
            <td>{{ product.reference }}</td>
            <td>{{ product.name }}</td>
            <td>{{ product.wholesalePrice }}</td>
            <td>{{ orderProduct.quantity }}</td>
            <td>{{ orderProduct.price }}</td>

        </tr>
    {% endfor %}
    </tbody>
</table>

<table class="total">
    <thead>
    <tr>
        <th class="grey">Total</th>
        <th class="b-grey">{{ order.price }}</th>
    </tr>
    </thead>
</table>


</body>
</html>